open Printf

let list = function
    [] -> ""
  | [s] -> s
  | l -> 
      let l' = List.rev l in
      String.concat ", " (List.rev (List.tl l')) ^ " and " ^ List.hd l'

let invalid_backref loc name =
  Stdpp.raise_with_loc loc
    (Failure
       (sprintf "Invalid backreference %s" name))

let unbalanced_bindings loc l =
  Stdpp.raise_with_loc loc
    (Failure 
       (sprintf "Variable%s %s must occur on both sides of this | pattern"
	  (if List.length l > 1 then "s" else "")
	  (list l)))

let multiple_binding loc l =
  let s, are =
    if List.length l > 1 then "s", "are"
    else "", "is" in
  Stdpp.raise_with_loc loc
    (Failure 
       (sprintf "Variable%s %s %s bound several times in this matching"
	  s (list l) are))

let invalid_range loc =
  Stdpp.raise_with_loc loc (Failure "Invalid range")

let invalid_pattern loc =
  Stdpp.raise_with_loc loc (Failure "Invalid pattern")

let invalid_lookbehind loc kind adjective =
  Stdpp.raise_with_loc loc 
    (Failure 
       (sprintf "%s are disabled in %slookbehind assertions" kind adjective))

let invalid_assertion loc kind adjective =
  Stdpp.raise_with_loc loc 
    (Failure 
       (sprintf "%s are disabled in %sassertions" kind adjective))
